diff -pruN 4.5.0-1/.github/workflows/build.yml 4.5.1-1/.github/workflows/build.yml
--- 4.5.0-1/.github/workflows/build.yml	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/.github/workflows/build.yml	2024-05-25 10:23:51.000000000 +0000
@@ -71,7 +71,7 @@ jobs:
         run: make clean && make
 
   macosx-build:
-    runs-on: macos-latest
+    runs-on: macos-11
     steps:
       - uses: actions/checkout@v2
       - name: Install dependencies
diff -pruN 4.5.0-1/.readthedocs.yaml 4.5.1-1/.readthedocs.yaml
--- 4.5.0-1/.readthedocs.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 4.5.1-1/.readthedocs.yaml	2024-05-25 10:23:51.000000000 +0000
@@ -0,0 +1,35 @@
+# Read the Docs configuration file for Sphinx projects
+# See https://docs.readthedocs.io/en/stable/config-file/v2.html for details
+
+# Required
+version: 2
+
+# Set the OS, Python version and other tools you might need
+build:
+  os: ubuntu-22.04
+  tools:
+    python: "3.12"
+    # You can also specify other tool versions:
+    # nodejs: "20"
+    # rust: "1.70"
+    # golang: "1.20"
+
+# Build documentation in the "docs/" directory with Sphinx
+sphinx:
+  configuration: docs/conf.py
+  # You can configure Sphinx to use a different builder, for instance use the dirhtml builder for simpler URLs
+  # builder: "dirhtml"
+  # Fail on all warnings to avoid broken references
+  # fail_on_warning: true
+
+# Optionally build your docs in additional formats such as PDF and ePub
+# formats:
+#   - pdf
+#   - epub
+
+# Optional but recommended, declare the Python requirements required
+# to build your documentation
+# See https://docs.readthedocs.io/en/stable/guides/reproducible-builds.html
+python:
+  install:
+    - requirements: docs/requirements.txt
diff -pruN 4.5.0-1/README.md 4.5.1-1/README.md
--- 4.5.0-1/README.md	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/README.md	2024-05-25 10:23:51.000000000 +0000
@@ -123,6 +123,7 @@ awesome list of [YARA-related stuff](htt
 * [SumoLogic](https://sumologic.com)
 * [Tanium](https://www.tanium.com/)
 * [Tenable Network Security](https://www.tenable.com/)
+* [Tenzir](https://tenzir.com)
 * [The DigiTrust Group](https://www.digitrustgroup.com/)
 * [ThreatConnect](https://www.threatconnect.com/)
 * [ThreatStream, Inc.](https://www.threatstream.com)
@@ -131,7 +132,9 @@ awesome list of [YARA-related stuff](htt
 * [TouchWeb](https://www.touchweb.fr)
 * [Trend Micro](https://www.trendmicro.com)
 * [UnpacMe](https://www.unpac.me)
+* [UpSight Security Inc.](https://upsight.ai/)
 * [Uptycs Inc](https://www.uptycs.com/)
+* [Verisys Antivirus API](https://www.ionxsolutions.com/products/verisys-virus-api)
 * [VirusTotal Intelligence](https://www.virustotal.com/intelligence/)
 * [VMRay](https://www.vmray.com/)
 * [Volexity](https://www.volexity.com/products-overview/volcano/)
diff -pruN 4.5.0-1/configure.ac 4.5.1-1/configure.ac
--- 4.5.0-1/configure.ac	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/configure.ac	2024-05-25 10:23:51.000000000 +0000
@@ -1,4 +1,4 @@
-AC_INIT([yara], [4.5.0], [vmalvarez@virustotal.com])
+AC_INIT([yara], [4.5.1], [vmalvarez@virustotal.com])
 
 AM_SILENT_RULES([yes])
 AC_CONFIG_SRCDIR([cli/yara.c])
@@ -32,9 +32,6 @@ AC_C_INLINE
 # Defines WORDS_BIGENDIAN if building in a big-endian host.
 AC_C_BIGENDIAN
 
-# Arrange for 64-bit file offsets.
-AC_SYS_LARGEFILE
-
 LT_INIT
 AC_CANONICAL_HOST
 
diff -pruN 4.5.0-1/debian/changelog 4.5.1-1/debian/changelog
--- 4.5.0-1/debian/changelog	2024-02-13 21:46:38.000000000 +0000
+++ 4.5.1-1/debian/changelog	2024-05-26 11:53:28.000000000 +0000
@@ -1,3 +1,12 @@
+yara (4.5.1-1) unstable; urgency=medium
+
+  * New upstream version 4.5.1
+  * Clean up rules
+  * Split build into arch-specific, arch-indep bits
+  * Update build-dependency
+
+ -- Hilko Bengen <bengen@debian.org>  Sun, 26 May 2024 13:53:28 +0200
+
 yara (4.5.0-1) unstable; urgency=medium
 
   * New upstream version 4.5.0
diff -pruN 4.5.0-1/debian/clean 4.5.1-1/debian/clean
--- 4.5.0-1/debian/clean	2024-02-13 21:46:28.000000000 +0000
+++ 4.5.1-1/debian/clean	2024-05-26 11:41:06.000000000 +0000
@@ -1,2 +1,3 @@
 test-arena-stream
 test-rules.yarc
+docs/_build
diff -pruN 4.5.0-1/debian/control 4.5.1-1/debian/control
--- 4.5.0-1/debian/control	2024-01-17 20:44:42.000000000 +0000
+++ 4.5.1-1/debian/control	2024-05-26 11:53:09.000000000 +0000
@@ -4,12 +4,13 @@ Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Hilko Bengen <bengen@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               python3-sphinx,
                flex, bison,
-               pkg-config,
+               pkgconf,
                libjansson-dev,
                libmagic-dev,
                libssl-dev,
+               sphinx-common,
+Build-Depends-Indep: python3-sphinx,
 Standards-Version: 4.6.0
 Homepage: https://virustotal.github.io/yara/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/yara.git
diff -pruN 4.5.0-1/debian/rules 4.5.1-1/debian/rules
--- 4.5.0-1/debian/rules	2024-01-17 20:44:42.000000000 +0000
+++ 4.5.1-1/debian/rules	2024-05-26 11:41:06.000000000 +0000
@@ -4,23 +4,17 @@
 %:
 	dh $@  --with sphinxdoc
 
-override_dh_auto_configure:
+override_dh_auto_configure-arch:
 	rm -f \
 		libyara/*grammar.[ch] \
 		libyara/*lexer.[ch]
 	dh_auto_configure -- --enable-cuckoo --enable-magic --enable-debug --enable-macho --enable-dex
 
-override_dh_auto_build:
+override_dh_auto_build-arch:
 	dh_auto_build
-	$(MAKE) -C docs html
-
-override_dh_auto_clean:
-	rm -rf yara-python/build docs/_build
-	dh_auto_clean
 
-override_dh_autoreconf:
-	mkdir -p m4 libyara/m4
-	dh_autoreconf
+override_dh_auto_build-indep:
+	$(MAKE) -C docs html
 
 override_dh_missing:
 	dh_missing -X.la
diff -pruN 4.5.0-1/docs/commandline.rst 4.5.1-1/docs/commandline.rst
--- 4.5.0-1/docs/commandline.rst	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/docs/commandline.rst	2024-05-25 10:23:51.000000000 +0000
@@ -148,6 +148,12 @@ Available options are:
 
   Scan files listed in FILE, one per line.
 
+.. option:: --strict-escape
+
+  Print warnings if a string contains an invalid escape sequence.
+
+  .. versionadded:: 4.5.0
+
 .. option:: -z <size> --skip-larger=<size>
 
   Skip files larger than the given <size> in bytes when scanning a directory.
diff -pruN 4.5.0-1/docs/conf.py 4.5.1-1/docs/conf.py
--- 4.5.0-1/docs/conf.py	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/docs/conf.py	2024-05-25 10:23:51.000000000 +0000
@@ -53,7 +53,7 @@ copyright = u'2014-2022, VirusTotal'
 # The short X.Y version.
 version = '4.5'
 # The full version, including alpha/beta/rc tags.
-release = '4.5.0'
+release = '4.5.1'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
diff -pruN 4.5.0-1/docs/requirements.txt 4.5.1-1/docs/requirements.txt
--- 4.5.0-1/docs/requirements.txt	1970-01-01 00:00:00.000000000 +0000
+++ 4.5.1-1/docs/requirements.txt	2024-05-25 10:23:51.000000000 +0000
@@ -0,0 +1 @@
+sphinx-rtd-theme==2.0.0
\ No newline at end of file
diff -pruN 4.5.0-1/docs/writingmodules.rst 4.5.1-1/docs/writingmodules.rst
--- 4.5.0-1/docs/writingmodules.rst	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/docs/writingmodules.rst	2024-05-25 10:23:51.000000000 +0000
@@ -659,7 +659,7 @@ checks in your code nevertheless). In th
         block = first_memory_block(context);
         if (block != NULL)
         {
-          block_data = block->fetch_data(block)
+          block_data = yr_fetch_block_data(block)
 
           if (block_data != NULL)
           {
@@ -668,15 +668,15 @@ checks in your code nevertheless). In th
         }
     }
 
-In the previous example you can also see how to use the ``fetch_data`` function.
-This function, which is a member of the ``YR_MEMORY_BLOCK`` structure, receives
-a pointer to the same block (as a ``self`` or ``this`` pointer) and returns a
-pointer to the block's data. Your module doesn't own the memory pointed to by
-this pointer, freeing that memory is not your responsibility. However keep in
-mind that the pointer is valid only until you ask for the next memory block. As
-long as you use the pointer within the scope of a ``foreach_memory_block`` you
-are on the safe side. Also take into account that ``fetch_data`` can return a
-NULL pointer, your code must be prepared for that case.
+In the previous example you can also see how to use the ``yr_fetch_block_data``
+function. This function receives a pointer to the same block (as a ``self`` or
+``this`` pointer) and returns a pointer to the block's data. Your module
+doesn't own the memory pointed to by this pointer, freeing that memory is not
+your responsibility. However keep in mind that the pointer is valid only until
+you ask for the next memory block. As long as you use the pointer within the
+scope of a ``foreach_memory_block`` you are on the safe side. Also take into
+account that ``yr_fetch_block_data`` can return a NULL pointer, your code must
+be prepared for that case.
 
 .. code-block:: c
 
@@ -684,7 +684,7 @@ NULL pointer, your code must be prepared
 
     foreach_memory_block(context, block)
     {
-      block_data = block->fetch_data(block);
+      block_data = yr_fetch_block_data(block);
 
       if (block_data != NULL)
       {
diff -pruN 4.5.0-1/docs/yarapython.rst 4.5.1-1/docs/yarapython.rst
--- 4.5.0-1/docs/yarapython.rst	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/docs/yarapython.rst	2024-05-25 10:23:51.000000000 +0000
@@ -119,12 +119,15 @@ should pass the ``externals`` parameter
 The ``externals`` parameter must be a dictionary with the names of the variables
 as keys and an associated value of either string, integer or boolean type.
 
-The ``compile`` method also accepts the optional boolean argument
+The ``compile`` method also accepts the optional boolean arguments telling yara-python
+how to deal with warnings. The first argument of this nature is
 ``error_on_warning``. This arguments tells YARA to raise an exception when a
 warning is issued during compilation. Such warnings are typically issued when
 your rules contains some construct that could be slowing down the scanning.
-The default value for the ``error_on_warning`` argument is False.
-
+The default value for the ``error_on_warning`` argument is False. The second argument of
+this type is another boolean, ``strict_escape``, when enabled this causes YARA to produce
+a warning when rules contain mis-escaped characters. The default value for the ``strict_escape`` 
+argument is False.
 
 In all cases ``compile`` returns an instance of the class :py:class:`yara.Rules`
 Rules. This class has a ``save`` method that can be used to save the compiled
@@ -145,9 +148,9 @@ example, you can save your rules to a me
 
 .. code-block:: python
 
-  import StringIO
+  import io
 
-  buff = StringIO.StringIO()
+  buff = io.BytesIO()
   rules.save(file=buff)
 
 The saved rules can be loaded from the memory buffer:
diff -pruN 4.5.0-1/libyara/base64.c 4.5.1-1/libyara/base64.c
--- 4.5.0-1/libyara/base64.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/base64.c	2024-05-25 10:23:51.000000000 +0000
@@ -375,7 +375,7 @@ int _yr_base64_create_regexp(
 // a result of the base64 encoding.
 //
 // This uses ideas from:
-// https://www.leeholmes.com/blog/2019/12/10/searching-for-content-in-base-64-strings-2/
+// https://www.leeholmes.com/searching-for-content-in-base-64-strings/
 //
 // This does not emit the code for the RE. A further call to yr_re_ast_emit_code
 // is required to get the code.
diff -pruN 4.5.0-1/libyara/exec.c 4.5.1-1/libyara/exec.c
--- 4.5.0-1/libyara/exec.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/exec.c	2024-05-25 10:23:51.000000000 +0000
@@ -1967,13 +1967,6 @@ int yr_execute_code(YR_SCAN_CONTEXT* con
       ensure_defined(r2);
       ensure_defined(r1);
 
-      if (r1.ss->length == 0)
-      {
-        r1.i = false;
-        push(r1);
-        break;
-      }
-
       result = yr_re_exec(
           context,
           (uint8_t*) r2.re->code,
diff -pruN 4.5.0-1/libyara/include/authenticode-parser/authenticode.h 4.5.1-1/libyara/include/authenticode-parser/authenticode.h
--- 4.5.0-1/libyara/include/authenticode-parser/authenticode.h	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/include/authenticode-parser/authenticode.h	2024-05-25 10:23:51.000000000 +0000
@@ -124,6 +124,8 @@ typedef struct {
     char* digest_alg;        /* Name of the digest algorithm used */
     ByteArray digest;        /* Stored message digest */
     CertificateArray* chain; /* Certificate chain of the signer */
+    CertificateArray* certs; /* All certs stored inside Countersignature, this can be superset
+                                of chain in case of non PKCS9 countersignature*/
 } Countersignature;
 
 typedef struct {
diff -pruN 4.5.0-1/libyara/include/yara/libyara.h 4.5.1-1/libyara/include/yara/libyara.h
--- 4.5.0-1/libyara/include/yara/libyara.h	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/include/yara/libyara.h	2024-05-25 10:23:51.000000000 +0000
@@ -34,7 +34,7 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 
 #define YR_MAJOR_VERSION 4
 #define YR_MINOR_VERSION 5
-#define YR_MICRO_VERSION 0
+#define YR_MICRO_VERSION 1
 
 #define version_str(s)  _version_str(s)
 #define _version_str(s) #s
diff -pruN 4.5.0-1/libyara/include/yara/pe.h 4.5.1-1/libyara/include/yara/pe.h
--- 4.5.0-1/libyara/include/yara/pe.h	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/include/yara/pe.h	2024-05-25 10:23:51.000000000 +0000
@@ -365,11 +365,12 @@ typedef struct _IMAGE_NT_HEADERS64
 // IMAGE_FIRST_SECTION doesn't need 32/64 versions since the file header is
 // the same either way.
 
-#define IMAGE_FIRST_SECTION(ntheader) \
-  ((PIMAGE_SECTION_HEADER)(                                             \
-      (BYTE*) ntheader + offsetof(IMAGE_NT_HEADERS32, OptionalHeader) + \
-      yr_le16toh(((PIMAGE_NT_HEADERS32)(ntheader))                      \
-                     ->FileHeader.SizeOfOptionalHeader)))
+#define IMAGE_FIRST_SECTION(ntheader)                                      \
+  ((PIMAGE_SECTION_HEADER) ((BYTE*) ntheader +                             \
+                            offsetof(IMAGE_NT_HEADERS32, OptionalHeader) + \
+                            yr_le16toh(                                    \
+                                ((PIMAGE_NT_HEADERS32) (ntheader))         \
+                                    ->FileHeader.SizeOfOptionalHeader)))
 
 // Subsystem Values
 
@@ -727,22 +728,22 @@ typedef struct _IMAGE_SYMBOL_EX
 // MACROS
 
 // Basic Type of  x
-#define BTYPE(x) ((x) &N_BTMASK)
+#define BTYPE(x) ((x) & N_BTMASK)
 
 // Is x a pointer?
 #ifndef ISPTR
-#define ISPTR(x) (((x) &N_TMASK) == (IMAGE_SYM_DTYPE_POINTER << N_BTSHFT))
+#define ISPTR(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_POINTER << N_BTSHFT))
 #endif
 
 // Is x a function?
 #ifndef ISFCN
-#define ISFCN(x) (((x) &N_TMASK) == (IMAGE_SYM_DTYPE_FUNCTION << N_BTSHFT))
+#define ISFCN(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_FUNCTION << N_BTSHFT))
 #endif
 
 // Is x an array?
 
 #ifndef ISARY
-#define ISARY(x) (((x) &N_TMASK) == (IMAGE_SYM_DTYPE_ARRAY << N_BTSHFT))
+#define ISARY(x) (((x) & N_TMASK) == (IMAGE_SYM_DTYPE_ARRAY << N_BTSHFT))
 #endif
 
 // Is x a structure, union, or enumeration TAG?
@@ -755,10 +756,10 @@ typedef struct _IMAGE_SYMBOL_EX
 #ifndef INCREF
 #define INCREF(x)                                                            \
   ((((x) & ~N_BTMASK) << N_TSHIFT) | (IMAGE_SYM_DTYPE_POINTER << N_BTSHFT) | \
-   ((x) &N_BTMASK))
+   ((x) & N_BTMASK))
 #endif
 #ifndef DECREF
-#define DECREF(x) ((((x) >> N_TSHIFT) & ~N_BTMASK) | ((x) &N_BTMASK))
+#define DECREF(x) ((((x) >> N_TSHIFT) & ~N_BTMASK) | ((x) & N_BTMASK))
 #endif
 
 #pragma pack(pop)
@@ -865,9 +866,9 @@ typedef struct _RICH_VERSION_INFO
 typedef struct _RICH_SIGNATURE
 {
   DWORD dans;
-  DWORD key1;
-  DWORD key2;
-  DWORD key3;
+  DWORD padding_1;
+  DWORD padding_2;
+  DWORD padding_3;
   RICH_VERSION_INFO versions[0];
 } RICH_SIGNATURE, *PRICH_SIGNATURE;
 
diff -pruN 4.5.0-1/libyara/include/yara/types.h 4.5.1-1/libyara/include/yara/types.h
--- 4.5.0-1/libyara/include/yara/types.h	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/include/yara/types.h	2024-05-25 10:23:51.000000000 +0000
@@ -293,8 +293,13 @@ struct YR_RULE
   // Number of atoms generated for this rule.
   int32_t num_atoms;
 
+  // Number of strings that must match for this rule to have some possibility
+  // to match.
   uint32_t required_strings;
 
+  // Just for padding.
+  uint32_t unused;
+
   DECLARE_REFERENCE(const char*, identifier);
   DECLARE_REFERENCE(const char*, tags);
   DECLARE_REFERENCE(YR_META*, metas);
diff -pruN 4.5.0-1/libyara/modules/dex/dex.c 4.5.1-1/libyara/modules/dex/dex.c
--- 4.5.0-1/libyara/modules/dex/dex.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/dex/dex.c	2024-05-25 10:23:51.000000000 +0000
@@ -328,6 +328,8 @@ begin_declarations
     declare_string("class_name");
     declare_string("name");
     declare_string("proto");
+    declare_integer("static");
+    declare_integer("instance");
     declare_integer("field_idx_diff");
     declare_integer("access_flags");
   end_struct_array("field")
@@ -358,11 +360,6 @@ begin_declarations
       declare_integer("debug_info_off");
       declare_integer("insns_size");
       declare_string("insns");
-      declare_integer("padding");
-      begin_struct("tries")
-      end_struct("tries");
-      begin_struct_array("handlers")
-      end_struct_array("handlers");
     end_struct("code_item")
   end_struct_array("method")
 end_declarations
@@ -492,19 +489,13 @@ dex_header_t* dex_get_header(const uint8
 void dex_parse_header(dex_header_t* dex_header, YR_OBJECT* module_object)
 {
   yr_set_sized_string(
-      (char*) dex_header->magic,
-      strnlen((char*) dex_header->magic, 8 * sizeof(char)),
-      module_object,
-      "header.magic");
+      (char*) dex_header->magic, 8, module_object, "header.magic");
 
   yr_set_integer(
       yr_le32toh(dex_header->checksum), module_object, "header.checksum");
 
   yr_set_sized_string(
-      (char*) dex_header->signature,
-      strnlen((char*) dex_header->signature, 20 * sizeof(char)),
-      module_object,
-      "header.signature");
+      (char*) dex_header->signature, 20, module_object, "header.signature");
 
   yr_set_integer(
       yr_le32toh(dex_header->file_size), module_object, "header.file_size");
@@ -1461,11 +1452,16 @@ int module_load(
 
   dex_header_t* dex_header;
 
-  yr_set_string(DEX_FILE_MAGIC_035, module_object, "DEX_FILE_MAGIC_035");
-  yr_set_string(DEX_FILE_MAGIC_036, module_object, "DEX_FILE_MAGIC_036");
-  yr_set_string(DEX_FILE_MAGIC_037, module_object, "DEX_FILE_MAGIC_037");
-  yr_set_string(DEX_FILE_MAGIC_038, module_object, "DEX_FILE_MAGIC_038");
-  yr_set_string(DEX_FILE_MAGIC_039, module_object, "DEX_FILE_MAGIC_039");
+  yr_set_sized_string(
+      DEX_FILE_MAGIC_035, 8, module_object, "DEX_FILE_MAGIC_035");
+  yr_set_sized_string(
+      DEX_FILE_MAGIC_036, 8, module_object, "DEX_FILE_MAGIC_036");
+  yr_set_sized_string(
+      DEX_FILE_MAGIC_037, 8, module_object, "DEX_FILE_MAGIC_037");
+  yr_set_sized_string(
+      DEX_FILE_MAGIC_038, 8, module_object, "DEX_FILE_MAGIC_038");
+  yr_set_sized_string(
+      DEX_FILE_MAGIC_039, 8, module_object, "DEX_FILE_MAGIC_039");
 
   yr_set_integer(0x12345678, module_object, "ENDIAN_CONSTANT");
   yr_set_integer(0x78563412, module_object, "REVERSE_ENDIAN_CONSTANT");
diff -pruN 4.5.0-1/libyara/modules/dotnet/dotnet.c 4.5.1-1/libyara/modules/dotnet/dotnet.c
--- 4.5.0-1/libyara/modules/dotnet/dotnet.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/dotnet/dotnet.c	2024-05-25 10:23:51.000000000 +0000
@@ -581,10 +581,10 @@ static int32_t read_blob_signed(const ui
   {
     uint16_t tmp1 = yr_be16toh(yr_unaligned_u16(*data));
     // shift and leave top 2 bits clear
-    uint16_t tmp2 = (tmp1 >> 1) & 0x3FFF;
+    int16_t tmp2 = (tmp1 >> 1) & 0x3FFF;
     // sign extension in case of negative number
     if (tmp1 & 0x1)
-      tmp2 |= 0xC000;
+      tmp2 |= 0xE000;
 
     *data += sizeof(uint16_t);
     *len -= sizeof(uint16_t);
@@ -602,10 +602,10 @@ static int32_t read_blob_signed(const ui
   {
     uint32_t tmp1 = yr_be32toh(yr_unaligned_u32(*data));
     // shift and leave top 3 bits clear
-    uint32_t tmp2 = (tmp1 >> 1) & 0x1FFFFFFF;
+    int32_t tmp2 = (tmp1 >> 1) & 0x1FFFFFFF;
     // sign extension in case of negative number
     if (tmp1 & 0x1)
-      tmp2 |= 0xE0000000;
+      tmp2 |= 0xF0000000;
 
     *data += sizeof(uint32_t);
     *len -= sizeof(uint32_t);
@@ -892,13 +892,15 @@ static char* parse_signature_type(
 
     // Read number of specified sizes
     uint32_t num_sizes = read_blob_unsigned(data, len);
-    sizes = yr_malloc(sizeof(uint32_t) * num_sizes);
-    if (!sizes || num_sizes > rank)
+    if (num_sizes > rank)
+      goto cleanup;
+    sizes = yr_malloc(sizeof(int64_t) * num_sizes);
+    if (!sizes)
       goto cleanup;
 
     for (uint32_t i = 0; i < num_sizes; ++i)
     {
-      sizes[i] = read_blob_unsigned(data, len);
+      sizes[i] = (int64_t) read_blob_unsigned(data, len);
     }
 
     // Read number of specified lower bounds
@@ -912,8 +914,8 @@ static char* parse_signature_type(
       lo_bounds[i] = read_blob_signed(data, len);
 
       // Adjust higher bound according to lower bound
-      if (num_sizes > i)
-        sizes[i] += lo_bounds[i];
+      if (num_sizes > i && lo_bounds[i] != 0)
+        sizes[i] += lo_bounds[i] - 1;
     }
 
     // Build the resulting array type
@@ -929,7 +931,7 @@ static char* parse_signature_type(
       {
         if (num_lowbounds > i && lo_bounds[i] != 0)
           sstr_appendf(ss, "%d...", lo_bounds[i]);
-        if (num_sizes > i && sizes[i] != 0)
+        if (num_sizes > i)
           sstr_appendf(ss, "%d", sizes[i]);
       }
       if (i + 1 != rank)
@@ -2932,10 +2934,6 @@ void dotnet_parse_tilde_2(
         index_size = 2;
 
       row_size = (4 + 4 + index_sizes.string + index_size);
-
-      // Using 'i' is insufficent since we may skip certain resources and
-      // it would give an inaccurate count in that case.
-      counter = 0;
       row_ptr = table_offset;
 
       // First DWORD is the offset.
@@ -2945,11 +2943,7 @@ void dotnet_parse_tilde_2(
           break;
 
         manifestresource_table = (PMANIFESTRESOURCE_TABLE) row_ptr;
-        resource_offset = yr_le32toh(manifestresource_table->Offset);
 
-        // Only set offset if it is in this file (implementation != 0).
-        // Can't use manifestresource_table here because the Name and
-        // Implementation fields are variable size.
         if (index_size == 4)
           implementation = yr_le32toh(
               *(DWORD*) (row_ptr + 4 + 4 + index_sizes.string));
@@ -2957,53 +2951,42 @@ void dotnet_parse_tilde_2(
           implementation = yr_le16toh(
               *(WORD*) (row_ptr + 4 + 4 + index_sizes.string));
 
+        row_ptr += row_size;
+
+        name = pe_get_dotnet_string(
+            pe,
+            string_offset,
+            str_heap_size,
+            DOTNET_STRING_INDEX(manifestresource_table->Name));
+
+        if (name != NULL)
+          yr_set_string(name, pe->object, "resources[%i].name", i);
+
+        // Only set offset and length if it is in this file, otherwise continue
+        // with the next resource.
         if (implementation != 0)
-        {
-          row_ptr += row_size;
           continue;
-        }
+
+        resource_offset = yr_le32toh(manifestresource_table->Offset);
 
         if (!fits_in_pe(
                 pe, pe->data + resource_base + resource_offset, sizeof(DWORD)))
-        {
-          row_ptr += row_size;
           continue;
-        }
 
         resource_size = yr_le32toh(
             *(DWORD*) (pe->data + resource_base + resource_offset));
 
-        if (!fits_in_pe(
-                pe, pe->data + resource_base + resource_offset, resource_size))
-        {
-          row_ptr += row_size;
-          continue;
-        }
-
         // Add 4 to skip the size.
         yr_set_integer(
             resource_base + resource_offset + 4,
             pe->object,
             "resources[%i].offset",
-            counter);
-
-        yr_set_integer(
-            resource_size, pe->object, "resources[%i].length", counter);
-
-        name = pe_get_dotnet_string(
-            pe,
-            string_offset,
-            str_heap_size,
-            DOTNET_STRING_INDEX(manifestresource_table->Name));
-
-        if (name != NULL)
-          yr_set_string(name, pe->object, "resources[%i].name", counter);
+            i);
 
-        row_ptr += row_size;
-        counter++;
+        yr_set_integer(resource_size, pe->object, "resources[%i].length", i);
       }
 
-      yr_set_integer(counter, pe->object, "number_of_resources");
+      yr_set_integer(i, pe->object, "number_of_resources");
 
       table_offset += row_size * num_rows;
       break;
@@ -3288,19 +3271,6 @@ static bool dotnet_is_dotnet(PE* pe)
         IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR)
       return false;
   }
-  else if (!(pe->header->FileHeader.Characteristics & IMAGE_FILE_DLL))  // 32bit
-  {
-    // Check first 2 bytes of the Entry point are equal to 0xFF 0x25
-    int64_t entry_offset = pe_rva_to_offset(
-        pe, yr_le32toh(pe->header->OptionalHeader.AddressOfEntryPoint));
-
-    if (entry_offset < 0 || !fits_in_pe(pe, pe->data + entry_offset, 2))
-      return false;
-
-    const uint8_t* entry_data = pe->data + entry_offset;
-    if (!(entry_data[0] == 0xFF && entry_data[1] == 0x25))
-      return false;
-  }
 
   return true;
 }
diff -pruN 4.5.0-1/libyara/modules/pe/authenticode-parser/authenticode.c 4.5.1-1/libyara/modules/pe/authenticode-parser/authenticode.c
--- 4.5.0-1/libyara/modules/pe/authenticode-parser/authenticode.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/authenticode-parser/authenticode.c	2024-05-25 10:23:51.000000000 +0000
@@ -114,23 +114,6 @@ static char* parse_program_name(ASN1_TYP
     return result;
 }
 
-/* Parses X509* certs into internal representation and inserts into CertificateArray
- * Array is assumed to have enough space to hold all certificates storted in the STACK */
-static void parse_certificates(const STACK_OF(X509) * certs, CertificateArray* result)
-{
-    int certCount = sk_X509_num(certs);
-    int i = 0;
-    for (; i < certCount; ++i) {
-        Certificate* cert = certificate_new(sk_X509_value(certs, i));
-        if (!cert)
-            break;
-
-        /* Write to the result */
-        result->certs[i] = cert;
-    }
-    result->count = i;
-}
-
 static void parse_nested_authenticode(PKCS7_SIGNER_INFO* si, AuthenticodeArray* result)
 {
     STACK_OF(X509_ATTRIBUTE)* attrs = PKCS7_get_attributes(si);
@@ -190,32 +173,6 @@ static void parse_pkcs9_countersig(PKCS7
     }
 }
 
-/* Extracts X509 certificates from MS countersignature and stores them into result */
-static void extract_ms_counter_certs(const uint8_t* data, int len, CertificateArray* result)
-{
-    PKCS7* p7 = d2i_PKCS7(NULL, &data, len);
-    if (!p7)
-        return;
-
-    /* We expect SignedData type of PKCS7 */
-    if (!PKCS7_type_is_signed(p7) || !p7->d.sign) {
-        PKCS7_free(p7);
-        return;
-    }
-
-    STACK_OF(X509)* certs = p7->d.sign->cert;
-    CertificateArray* certArr = certificate_array_new(sk_X509_num(certs));
-    if (!certArr) {
-        PKCS7_free(p7);
-        return;
-    }
-    parse_certificates(certs, certArr);
-    certificate_array_move(result, certArr);
-    certificate_array_free(certArr);
-
-    PKCS7_free(p7);
-}
-
 static void parse_ms_countersig(PKCS7* p7, Authenticode* auth)
 {
     PKCS7_SIGNER_INFO* si = sk_PKCS7_SIGNER_INFO_value(PKCS7_get_signer_info(p7), 0);
@@ -239,14 +196,14 @@ static void parse_ms_countersig(PKCS7* p
         int len = nested->value.sequence->length;
         const uint8_t* data = nested->value.sequence->data;
 
-        Countersignature* sig = ms_countersig_new(data, len, si->enc_digest);
-        if (!sig)
+        Countersignature* csig = ms_countersig_new(data, len, si->enc_digest);
+        if (!csig)
             return;
 
+        countersignature_array_insert(auth->countersigs, csig);
         /* Because MS TimeStamp countersignature has it's own SET of certificates
          * extract it back into parent signature for consistency with PKCS9 */
-        countersignature_array_insert(auth->countersigs, sig);
-        extract_ms_counter_certs(data, len, auth->certs);
+        certificate_array_append(auth->certs, csig->certs);
     }
 }
 
@@ -344,7 +301,7 @@ AuthenticodeArray* authenticode_new(cons
         auth->verify_flags = AUTHENTICODE_VFY_INTERNAL_ERROR;
         goto end;
     }
-    parse_certificates(certs, auth->certs);
+    parse_x509_certificates(certs, auth->certs);
 
     /* Get Signature content that contains the message digest and it's algorithm */
     SpcIndirectDataContent* dataContent = get_content(p7data->contents);
diff -pruN 4.5.0-1/libyara/modules/pe/authenticode-parser/certificate.c 4.5.1-1/libyara/modules/pe/authenticode-parser/certificate.c
--- 4.5.0-1/libyara/modules/pe/authenticode-parser/certificate.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/authenticode-parser/certificate.c	2024-05-25 10:23:51.000000000 +0000
@@ -330,10 +330,82 @@ Certificate* certificate_new(X509* x509)
     return result;
 }
 
+void attributes_copy(Attributes* dst, Attributes* src)
+{
+    byte_array_init(&dst->country, src->country.data, src->country.len);
+    byte_array_init(&dst->organization, src->organization.data, src->organization.len);
+    byte_array_init(
+        &dst->organizationalUnit, src->organizationalUnit.data, src->organizationalUnit.len);
+    byte_array_init(&dst->nameQualifier, src->nameQualifier.data, src->nameQualifier.len);
+    byte_array_init(&dst->state, src->state.data, src->state.len);
+    byte_array_init(&dst->commonName, src->commonName.data, src->commonName.len);
+    byte_array_init(&dst->serialNumber, src->serialNumber.data, src->serialNumber.len);
+    byte_array_init(&dst->locality, src->locality.data, src->locality.len);
+    byte_array_init(&dst->title, src->title.data, src->title.len);
+    byte_array_init(&dst->surname, src->surname.data, src->surname.len);
+    byte_array_init(&dst->givenName, src->givenName.data, src->givenName.len);
+    byte_array_init(&dst->initials, src->initials.data, src->initials.len);
+    byte_array_init(&dst->pseudonym, src->pseudonym.data, src->pseudonym.len);
+    byte_array_init(
+        &dst->generationQualifier, src->generationQualifier.data, src->generationQualifier.len);
+    byte_array_init(&dst->emailAddress, src->emailAddress.data, src->emailAddress.len);
+}
+
+/* Parses X509* certs into internal representation and inserts into CertificateArray
+ * Array is assumed to have enough space to hold all certificates storted in the STACK */
+void parse_x509_certificates(const STACK_OF(X509) * certs, CertificateArray* result)
+{
+    int certCount = sk_X509_num(certs);
+    int i = 0;
+    for (; i < certCount; ++i) {
+        Certificate* cert = certificate_new(sk_X509_value(certs, i));
+        if (!cert)
+            break;
+
+        /* Write to the result */
+        result->certs[i] = cert;
+    }
+    result->count = i;
+}
+
+/* Creates deep copy of a certificate */
+Certificate* certificate_copy(Certificate* cert)
+{
+    if (!cert)
+        return NULL;
+
+    Certificate* result = (Certificate*)calloc(1, sizeof(*result));
+    if (!result)
+        return NULL;
+
+    result->version = cert->version;
+    result->issuer = cert->issuer ? strdup(cert->issuer) : NULL;
+    result->subject = cert->subject ? strdup(cert->subject) : NULL;
+    result->serial = cert->serial ? strdup(cert->serial) : NULL;
+    result->not_after = cert->not_after;
+    result->not_before = cert->not_before;
+    result->sig_alg = cert->sig_alg ? strdup(cert->sig_alg) : NULL;
+    result->sig_alg_oid = cert->sig_alg_oid ? strdup(cert->sig_alg_oid) : NULL;
+    result->key_alg = cert->key_alg ? strdup(cert->key_alg) : NULL;
+    result->key = cert->key ? strdup(cert->key) : NULL;
+    byte_array_init(&result->sha1, cert->sha1.data, cert->sha1.len);
+    byte_array_init(&result->sha256, cert->sha256.data, cert->sha256.len);
+    attributes_copy(&result->issuer_attrs, &cert->issuer_attrs);
+    attributes_copy(&result->subject_attrs, &cert->subject_attrs);
+
+    return result;
+}
+
 /* Moves certificates from src to dst, returns 0 on success,
  * else 1. If error occurs, arguments are unchanged */
 int certificate_array_move(CertificateArray* dst, CertificateArray* src)
 {
+    if (!dst || !src)
+        return 1;
+
+    if (!src->certs || !src->count)
+        return 0;
+
     size_t newCount = dst->count + src->count;
 
     Certificate** tmp = (Certificate**)realloc(dst->certs, newCount * sizeof(Certificate*));
@@ -353,6 +425,32 @@ int certificate_array_move(CertificateAr
 
     return 0;
 }
+
+/* Copies certificates from src and appends to dst, returns 0 on success,
+ * else 1. If error occurs, arguments are unchanged */
+int certificate_array_append(CertificateArray* dst, CertificateArray* src)
+{
+    if (!dst || !src)
+        return 1;
+
+    if (!src->certs || !src->count)
+        return 0;
+
+    size_t newCount = dst->count + src->count;
+
+    Certificate** tmp = (Certificate**)realloc(dst->certs, newCount * sizeof(Certificate*));
+    if (!tmp)
+        return 1;
+
+    dst->certs = tmp;
+
+    for (size_t i = 0; i < src->count; ++i)
+        dst->certs[i + dst->count] = certificate_copy(src->certs[i]);
+
+    dst->count = newCount;
+
+    return 0;
+}
 
 /* Allocates empty certificate array with reserved space for certCount certs */
 CertificateArray* certificate_array_new(int certCount)
diff -pruN 4.5.0-1/libyara/modules/pe/authenticode-parser/certificate.h 4.5.1-1/libyara/modules/pe/authenticode-parser/certificate.h
--- 4.5.0-1/libyara/modules/pe/authenticode-parser/certificate.h	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/authenticode-parser/certificate.h	2024-05-25 10:23:51.000000000 +0000
@@ -31,10 +31,14 @@ extern "C" {
 #endif
 
 Certificate* certificate_new(X509* x509);
+Certificate* certificate_copy(Certificate* cert);
 void certificate_free(Certificate* cert);
 
+void parse_x509_certificates(const STACK_OF(X509) * certs, CertificateArray* result);
+
 CertificateArray* parse_signer_chain(X509* signer_cert, STACK_OF(X509) * certs);
 int certificate_array_move(CertificateArray* dst, CertificateArray* src);
+int certificate_array_append(CertificateArray* dst, CertificateArray* src);
 CertificateArray* certificate_array_new(int certCount);
 void certificate_array_free(CertificateArray* arr);
 
diff -pruN 4.5.0-1/libyara/modules/pe/authenticode-parser/countersignature.c 4.5.1-1/libyara/modules/pe/authenticode-parser/countersignature.c
--- 4.5.0-1/libyara/modules/pe/authenticode-parser/countersignature.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/authenticode-parser/countersignature.c	2024-05-25 10:23:51.000000000 +0000
@@ -357,7 +357,6 @@ int IMPL_FUNC_NAME(verify_digest, pkcs7)
 
     X509_STORE* store = X509_STORE_new();
     TS_VERIFY_CTX* ctx = TS_VERIFY_CTX_new();
-    TS_VERIFY_CTX_init(ctx);
 
     TS_VERIFY_CTX_set_flags(ctx, TS_VFY_VERSION | TS_VFY_IMPRINT);
     TS_VERIFY_CTX_set_store(ctx, store);
@@ -457,6 +456,9 @@ CountersignatureImpl* ms_countersig_impl
         result->funcs = &FUNC_ARRAY_NAME_FOR_IMPL(pkcs7);
         result->pkcs7 = p7;
         return result;
+    } else if (p7) {
+        PKCS7_free(p7);
+        return NULL;
     }
 
     d = data;
@@ -527,6 +529,16 @@ Countersignature* ms_countersig_new(cons
     }
 
     STACK_OF(X509)* certs = impl->funcs->get_certs(impl);
+
+    /* MS Counter signatures (PKCS7/CMS) can have extra certificates that are not part of a chain */
+    result->certs = certificate_array_new(sk_X509_num(certs));
+    if (!result->certs) {
+        result->verify_flags = AUTHENTICODE_VFY_INTERNAL_ERROR;
+        goto end;
+    }
+
+    parse_x509_certificates(certs, result->certs);
+
     result->chain = parse_signer_chain(signCert, certs);
 
     /* Imprint == digest */
@@ -642,6 +654,7 @@ void countersignature_free(Countersignat
         free(sig->digest_alg);
         free(sig->digest.data);
         certificate_array_free(sig->chain);
+        certificate_array_free(sig->certs);
         free(sig);
     }
 }
diff -pruN 4.5.0-1/libyara/modules/pe/pe.c 4.5.1-1/libyara/modules/pe/pe.c
--- 4.5.0-1/libyara/modules/pe/pe.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/pe.c	2024-05-25 10:23:51.000000000 +0000
@@ -204,19 +204,6 @@ static void pe_parse_rich_signature(PE*
   if (rich_signature == NULL)
     return;
 
-  // The three key values must all be equal and the first dword
-  // XORs to "DanS". Then walk the buffer looking for "Rich" which marks the
-  // end. Technically the XOR key should be right after "Rich" but it's not
-  // important.
-
-  if (yr_le32toh(rich_signature->key1) != yr_le32toh(rich_signature->key2) ||
-      yr_le32toh(rich_signature->key2) != yr_le32toh(rich_signature->key3) ||
-      (yr_le32toh(rich_signature->dans) ^ yr_le32toh(rich_signature->key1)) !=
-          RICH_DANS)
-  {
-    return;
-  }
-
   // Multiply by 4 because we are counting in DWORDs.
   rich_len = (rich_ptr - (DWORD*) rich_signature) * 4;
   raw_data = (BYTE*) yr_malloc(rich_len);
@@ -232,9 +219,7 @@ static void pe_parse_rich_signature(PE*
       "rich_signature.offset");
 
   yr_set_integer(rich_len, pe->object, "rich_signature.length");
-
-  yr_set_integer(
-      yr_le32toh(rich_signature->key1), pe->object, "rich_signature.key");
+  yr_set_integer(yr_le32toh(key), pe->object, "rich_signature.key");
 
   clear_data = (BYTE*) yr_malloc(rich_len);
 
@@ -251,7 +236,7 @@ static void pe_parse_rich_signature(PE*
        rich_ptr < (DWORD*) (clear_data + rich_len);
        rich_ptr++)
   {
-    *rich_ptr ^= rich_signature->key1;
+    *rich_ptr ^= key;
   }
 
   yr_set_sized_string(
@@ -383,7 +368,7 @@ static void pe_parse_debug_directory(PE*
       pdb_path_len = strnlen(
           pdb_path, yr_min(available_space(pe, pdb_path), MAX_PATH));
 
-      if (pdb_path_len > 0 && pdb_path_len < MAX_PATH)
+      if (pdb_path_len >= 0 && pdb_path_len < MAX_PATH)
       {
         yr_set_sized_string(pdb_path, pdb_path_len, pe->object, "pdb_path");
         break;
@@ -466,13 +451,14 @@ static int _pe_iterate_resources(
 
   entry = (PIMAGE_RESOURCE_DIRECTORY_ENTRY) (resource_dir + 1);
 
+  if (!fits_in_pe(
+          pe, entry, total_entries * sizeof(IMAGE_RESOURCE_DIRECTORY_ENTRY)))
+    return result;
+
   for (i = 0; i < total_entries; i++)
   {
-    if (!struct_fits_in_pe(pe, entry, IMAGE_RESOURCE_DIRECTORY_ENTRY))
-    {
-      result = RESOURCE_ITERATOR_ABORTED;
-      break;
-    }
+    if (yr_le32toh(entry->OffsetToData) == 0)
+      continue;
 
     switch (rsrc_tree_level)
     {
@@ -511,10 +497,6 @@ static int _pe_iterate_resources(
             callback,
             callback_data);
       }
-      else
-      {
-        result = RESOURCE_ITERATOR_ABORTED;
-      }
     }
     else
     {
@@ -523,23 +505,23 @@ static int _pe_iterate_resources(
 
       if (struct_fits_in_pe(pe, data_entry, IMAGE_RESOURCE_DATA_ENTRY))
       {
-        if (callback(
-                data_entry,
-                *type,
-                *id,
-                *language,
-                type_string,
-                name_string,
-                lang_string,
-                callback_data) == RESOURCE_CALLBACK_ABORT)
+        if (yr_le32toh(data_entry->Size) > 0 &&
+            yr_le32toh(data_entry->Size) < pe->data_size)
         {
-          result = RESOURCE_ITERATOR_ABORTED;
+          if (callback(
+                  data_entry,
+                  *type,
+                  *id,
+                  *language,
+                  type_string,
+                  name_string,
+                  lang_string,
+                  callback_data) == RESOURCE_CALLBACK_ABORT)
+          {
+            result = RESOURCE_ITERATOR_ABORTED;
+          }
         }
       }
-      else
-      {
-        result = RESOURCE_ITERATOR_ABORTED;
-      }
     }
 
     if (result == RESOURCE_ITERATOR_ABORTED)
@@ -741,7 +723,8 @@ static void pe_set_resource_string_or_id
   }
   else
   {
-    yr_set_integer(rsrc_int, pe->object, int_description, pe->resources);
+    if (rsrc_int != -1)
+      yr_set_integer(rsrc_int, pe->object, int_description, pe->resources);
   }
 }
 
@@ -756,7 +739,7 @@ static int pe_collect_resources(
     PE* pe)
 {
   // Don't collect too many resources.
-  if (pe->resources > MAX_RESOURCES)
+  if (pe->resources >= MAX_RESOURCES)
     return RESOURCE_CALLBACK_CONTINUE;
 
   yr_set_integer(
@@ -888,11 +871,15 @@ static IMPORT_FUNCTION* pe_parse_import_
       }
       else
       {
-        // If imported by ordinal. Lookup the ordinal.
-        name = ord_lookup(dll_name, yr_le64toh(thunks64->u1.Ordinal) & 0xFFFF);
-        // Also store the ordinal.
-        ordinal = yr_le64toh(thunks64->u1.Ordinal) & 0xFFFF;
-        has_ordinal = 1;
+        // The maximum possible value for the ordinal is when the high
+        // bit is set (indicating import by ordinal) and the low bits
+        // are FFFF. The maximum number of ordinal exports is 65536.
+        if (yr_le64toh(thunks64->u1.Ordinal) <= 0x800000000000ffff)
+        {
+          ordinal = yr_le64toh(thunks64->u1.Ordinal) & 0xFFFF;
+          name = ord_lookup(dll_name, ordinal);
+          has_ordinal = 1;
+        }
       }
 
       rva_address = yr_le32toh(import_descriptor->FirstThunk) +
@@ -974,11 +961,15 @@ static IMPORT_FUNCTION* pe_parse_import_
       }
       else
       {
-        // If imported by ordinal. Lookup the ordinal.
-        name = ord_lookup(dll_name, yr_le32toh(thunks32->u1.Ordinal) & 0xFFFF);
-        // Also store the ordinal.
-        ordinal = yr_le32toh(thunks32->u1.Ordinal) & 0xFFFF;
-        has_ordinal = 1;
+        // The maximum possible value for the ordinal is when the high
+        // bit is set (indicating import by ordinal) and the low bits
+        // are FFFF. The maximum number of ordinal exports is 65536.
+        if (yr_le32toh(thunks32->u1.Ordinal) <= 0x8000ffff)
+        {
+          ordinal = yr_le32toh(thunks32->u1.Ordinal) & 0xFFFF;
+          name = ord_lookup(dll_name, ordinal);
+          has_ordinal = 1;
+        }
       }
 
       rva_address = yr_le32toh(import_descriptor->FirstThunk) +
@@ -1029,9 +1020,9 @@ static IMPORT_FUNCTION* pe_parse_import_
 }
 
 //
-// In Windows PE files, any character including 0x20 and above is allowed.
-// The only exceptions are characters that are invalid for file names in
-// Windows, which are "*<>?|. While they still can be present in the import
+// In Windows PE files, any printable character including 0x20 and above is
+// allowed. The only exceptions are characters that are invalid for file names
+// in Windows, which are "*<>?|. While they still can be present in the import
 // directory, such module can never be present in Windows, so we can treat them
 // as invalid.
 //
@@ -1061,8 +1052,8 @@ static int pe_valid_dll_name(const char*
 
   while (l < n && *c != '\0')
   {
-    if (*c < ' ' || *c == '\"' || *c == '*' || *c == '<' || *c == '>' ||
-        *c == '?' || *c == '|')
+    if (*c < ' ' || *c > 0x7e || *c == '\"' || *c == '*' || *c == '<' ||
+        *c == '>' || *c == '?' || *c == '|')
     {
       return false;
     }
@@ -1288,6 +1279,10 @@ uint64_t pe_parse_delay_import_pointer(
     uint64_t rva)
 {
   const int64_t offset = pe_rva_to_offset(pe, rva);
+
+  if (offset < 0)
+    return YR_UNDEFINED;
+
   const uint8_t* data = pe->data + offset;
 
   if (!fits_in_pe(pe, data, pointerSize))
@@ -1428,17 +1423,8 @@ static void* pe_parse_delayed_imports(PE
       if (nameAddress == 0 || funcAddress == 0)
         break;
 
-      IMPORT_FUNCTION* imported_func = (IMPORT_FUNCTION*) yr_malloc(
-          sizeof(IMPORT_FUNCTION));
-
-      if (imported_func == NULL)
-        continue;
-
-      imported_func->name = NULL;
-      imported_func->has_ordinal = 0;
-      imported_func->ordinal = 0;
-      imported_func->rva = 0;
-      imported_func->next = NULL;
+      char* func_name;
+      uint8_t has_ordinal = 0;
 
       // Check name address. It could be ordinal, VA or RVA
       if (!(nameAddress & ordinal_mask))
@@ -1450,21 +1436,35 @@ static void* pe_parse_delayed_imports(PE
 
         offset = pe_rva_to_offset(pe, nameAddress + sizeof(uint16_t));
 
-        imported_func->name = (char*) yr_strndup(
+        if (offset < 0)
+        {
+          name_rva += pointer_size;
+          func_rva += pointer_size;
+          continue;
+        }
+
+        func_name = (char*) yr_strndup(
             (char*) (pe->data + offset),
             yr_min(available_space(pe, (char*) (pe->data + offset)), 512));
       }
       else
       {
         // If imported by ordinal. Lookup the ordinal.
-        imported_func->name = ord_lookup(dll_name, nameAddress & 0xFFFF);
-
-        // Also store the ordinal.
-        imported_func->ordinal = nameAddress & 0xFFFF;
-        imported_func->has_ordinal = 1;
+        func_name = ord_lookup(dll_name, nameAddress & 0xFFFF);
+        has_ordinal = 1;
       }
 
+      IMPORT_FUNCTION* imported_func = (IMPORT_FUNCTION*) yr_malloc(
+          sizeof(IMPORT_FUNCTION));
+
+      if (imported_func == NULL)
+        break;
+
+      imported_func->name = func_name;
       imported_func->rva = func_rva;
+      imported_func->has_ordinal = has_ordinal;
+      imported_func->ordinal = (has_ordinal) ? nameAddress & 0xFFFF : 0;
+      imported_func->next = NULL;
 
       num_function_imports++;
       name_rva += pointer_size;
@@ -1762,6 +1762,22 @@ void _process_authenticode(
   for (size_t i = 0; i < auth_array->count; ++i)
   {
     const Authenticode* authenticode = auth_array->signatures[i];
+
+    if (authenticode->verify_flags == AUTHENTICODE_VFY_CANT_PARSE)
+      continue;
+
+    if (authenticode->verify_flags == AUTHENTICODE_VFY_WRONG_PKCS7_TYPE)
+      continue;
+
+    if (authenticode->verify_flags == AUTHENTICODE_VFY_NO_SIGNER_INFO)
+      continue;
+
+    if (authenticode->verify_flags == AUTHENTICODE_VFY_NO_SIGNER_CERT)
+      continue;
+
+    if (authenticode->verify_flags == AUTHENTICODE_VFY_INTERNAL_ERROR)
+      continue;
+
     bool verified = authenticode->verify_flags == AUTHENTICODE_VFY_VALID;
 
     /* If any signature is valid -> file is correctly signed */
@@ -2031,15 +2047,20 @@ const char* pe_get_section_full_name(
   // Check string
   for (uint64_t len = 0; fits_in_pe(pe, string, len + 1); len++)
   {
+    // Prevent sign extension to 32-bits on bytes > 0x7F
+    // The result negative integer would cause assert in MSVC debug version of
+    // isprint()
+    unsigned int one_char = (unsigned char) (string[len]);
+
     // Valid string
-    if (string[len] == 0)
+    if (one_char == 0)
     {
       *section_full_name_length = len;
       return string;
     }
 
     // string contain unprintable character
-    if (!isprint(string[len]))
+    if (!isprint(one_char))
       return NULL;
   }
 
@@ -2053,7 +2074,10 @@ static void pe_parse_header(PE* pe, uint
   PIMAGE_DATA_DIRECTORY data_dir;
 
   char section_name[IMAGE_SIZEOF_SHORT_NAME + 1];
-  int sect_name_length, scount, ddcount;
+  int sect_name_length;
+
+  uint16_t scount;
+  uint32_t ddcount;
 
   uint64_t highest_sec_siz = 0;
   uint64_t highest_sec_ofs = 0;
diff -pruN 4.5.0-1/libyara/modules/pe/pe_utils.c 4.5.1-1/libyara/modules/pe/pe_utils.c
--- 4.5.0-1/libyara/modules/pe/pe_utils.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/modules/pe/pe_utils.c	2024-05-25 10:23:51.000000000 +0000
@@ -29,6 +29,7 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 
 #include <stdio.h>
 #include <string.h>
+#include <yara/dotnet.h>
 #include <yara/endian.h>
 #include <yara/integers.h>
 #include <yara/mem.h>
@@ -36,7 +37,6 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 #include <yara/pe_utils.h>
 #include <yara/strutils.h>
 #include <yara/utils.h>
-#include <yara/dotnet.h>
 
 PIMAGE_NT_HEADERS32 pe_get_header(const uint8_t* data, size_t data_size)
 {
@@ -62,7 +62,7 @@ PIMAGE_NT_HEADERS32 pe_get_header(const
   if (data_size < headers_size)
     return NULL;
 
-  pe_header = (PIMAGE_NT_HEADERS32)(data + yr_le32toh(mz_header->e_lfanew));
+  pe_header = (PIMAGE_NT_HEADERS32) (data + yr_le32toh(mz_header->e_lfanew));
 
   if (yr_le32toh(pe_header->Signature) != IMAGE_NT_SIGNATURE)
     return NULL;
@@ -81,29 +81,17 @@ PIMAGE_NT_HEADERS32 pe_get_header(const
   return pe_header;
 }
 
-
 PIMAGE_DATA_DIRECTORY pe_get_directory_entry(PE* pe, int entry)
 {
-  // Explanation
-  // https://github.com/VirusTotal/yara/issues/1525
-
-  // In Windows, any access to data directories is controlled by the
-  // RtlImageDirectoryEntryToData function. This is one of the first checks
-  // whether the desired directory entry is smaller than NumberOfRvaAndSizes.
-  // If it's not, it means that the requested directory entry is not there.
-  //
-  //  1. Must NOT check whether NumberOfRvaAndSizes > 0x10
-  //
-  //  2. Must check for NumberOfRvaAndSizes < DataDirectory except for 
-  //     IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR for 32-bit binary
-  //
-  //  3. The function must NOT check for SizeOfOptionalHeader
-
-
-  if ((entry != IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR || IS_64BITS_PE(pe)) &&
-      OptionalHeader(pe, NumberOfRvaAndSizes) < entry)
-    return NULL;
-
+  // In theory, `entry` should be lower than NumberOfRvaAndSizes, however,
+  // we don't enforce it because some PE files have a NumberOfRvaAndSizes
+  // values lower than the actual number of directory entries. For example,
+  // file 0aa527fd26c8e7fa7f3476b6d7eb8f22c071ff4c0fd3ed3797fa90ceb80f24ce
+  // has NumberOfRvaAndSizes set to 0, but it actually has directory
+  // entries. If we are overly strict here, and only parse entries which are
+  // less than NumberOfRvaAndSizes, we run the risk of missing otherwise
+  // perfectly valid files (valid in the sense that they can be parsed, even
+  // if they are not valid for the Windows loader).
   PIMAGE_DATA_DIRECTORY result = &OptionalHeader(pe, DataDirectory)[entry];
 
   // Check that directory is in file
@@ -113,7 +101,6 @@ PIMAGE_DATA_DIRECTORY pe_get_directory_e
   return result;
 }
 
-
 int64_t pe_rva_to_offset(PE* pe, uint64_t rva)
 {
   PIMAGE_SECTION_HEADER section = IMAGE_FIRST_SECTION(pe->header);
@@ -141,10 +128,16 @@ int64_t pe_rva_to_offset(PE* pe, uint64_
         lowest_section_rva = yr_le32toh(section->VirtualAddress);
       }
 
-      uint32_t virtualSize = yr_le32toh(
-          section->Misc.VirtualSize != 0 ?
-          section->Misc.VirtualSize :
-          section->SizeOfRawData);
+      // In theory, we should use the section's virtual size while
+      // checking if some RVA is within the section. In most cases
+      // the virtual size is greater than the raw data size, but that's
+      // not always the case. So we use the larger of the two values.
+      //
+      // Example:
+      // db6a9934570fa98a93a979e7e0e218e0c9710e5a787b18c6948f2eedd9338984
+      uint32_t virtualSize = yr_max(
+          yr_le32toh(section->Misc.VirtualSize),
+          yr_le32toh(section->SizeOfRawData));
 
       if (rva >= yr_le32toh(section->VirtualAddress) &&
           rva - yr_le32toh(section->VirtualAddress) < virtualSize &&
@@ -176,10 +169,10 @@ int64_t pe_rva_to_offset(PE* pe, uint64_
             section_offset -= rest;
         }
 
-        // For multi-section images, real pointer to raw data is aligned down to sector size
+        // For multi-section images, real pointer to raw data is aligned down to
+        // sector size
         if (yr_le32toh(OptionalHeader(pe, SectionAlignment)) >= PE_PAGE_SIZE)
           section_offset = section_offset & ~(PE_SECTOR_SIZE - 1);
-
       }
 
       section++;
@@ -217,7 +210,6 @@ int64_t pe_rva_to_offset(PE* pe, uint64_
   return result;
 }
 
-
 #if !HAVE_TIMEGM
 #if HAVE__MKGMTIME
 #define timegm _mkgmtime
@@ -231,7 +223,6 @@ static bool is_leap(unsigned int year)
   return (year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0);
 }
 
-
 time_t timegm(struct tm* tm)
 {
   static const unsigned ndays[2][12] = {
@@ -259,7 +250,6 @@ time_t timegm(struct tm* tm)
 #endif  // HAVE__MKGMTIME
 #endif  // !HAVE_TIMEGM
 
-
 // These ordinals are taken from pefile. If a lookup fails attempt to return
 // "ordN" and if that fails, return NULL. The caller is responsible for freeing
 // the returned string.
diff -pruN 4.5.0-1/libyara/proc/linux.c 4.5.1-1/libyara/proc/linux.c
--- 4.5.0-1/libyara/proc/linux.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/proc/linux.c	2024-05-25 10:23:51.000000000 +0000
@@ -29,6 +29,8 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 
 #if defined(USE_LINUX_PROC)
 
+#define _FILE_OFFSET_BITS 64
+
 #include <assert.h>
 #include <errno.h>
 #include <fcntl.h>
@@ -249,7 +251,7 @@ YR_API const uint8_t* yr_process_fetch_m
   // target process VM.
   if (fd == -1)
   {
-    if (pread64(
+    if (pread(
             proc_info->mem_fd,
             (void*) context->buffer,
             block->size,
@@ -265,7 +267,7 @@ YR_API const uint8_t* yr_process_fetch_m
     {
       goto _exit;
     }
-    if (pread64(
+    if (pread(
             proc_info->pagemap_fd,
             pagemap,
             sizeof(uint64_t) * block->size / page_size,
@@ -284,7 +286,7 @@ YR_API const uint8_t* yr_process_fetch_m
       // swap-backed and if it differs from our mapping.
       uint8_t buffer[page_size];
 
-      if (pread64(
+      if (pread(
               proc_info->mem_fd,
               buffer,
               page_size,
diff -pruN 4.5.0-1/libyara/re.c 4.5.1-1/libyara/re.c
--- 4.5.0-1/libyara/re.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/re.c	2024-05-25 10:23:51.000000000 +0000
@@ -1947,7 +1947,8 @@ int yr_re_exec(
 
       case RE_OPCODE_WORD_BOUNDARY:
       case RE_OPCODE_NON_WORD_BOUNDARY:
-        if (input - input_incr + character_size <= input_data + input_forwards_size &&
+        if (input - input_incr + character_size <=
+                input_data + input_forwards_size &&
             input - input_incr >= input_data - input_backwards_size)
         {
           prev_is_word_char = _yr_re_is_word_char(
@@ -2336,15 +2337,15 @@ int yr_re_fast_exec(
           // an item that has a pointer lower or equal than next_input, but
           // whose next item have a pointer that is larger.
           while (insertion_point->next != NULL &&
-                 next_input >= insertion_point->next->input)
+                 insertion_point->next->input <= next_input)
           {
             insertion_point = insertion_point->next;
           }
 
-          // If the pointer at the insertion point is equal to next_input we
-          // don't need to insert next_input in the list as this input already
-          // exists.
-          if (next_input == insertion_point->input)
+          // If the input already exists for the next round, we don't need to
+          // insert it.
+          if (insertion_point->round == round + 1 &&
+              insertion_point->input == next_input)
             continue;
 
           // The next opcode is RE_OPCODE_LITERAL, but the literal doesn't
diff -pruN 4.5.0-1/libyara/re_lexer.c 4.5.1-1/libyara/re_lexer.c
--- 4.5.0-1/libyara/re_lexer.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/re_lexer.c	2024-05-25 10:23:51.000000000 +0000
@@ -589,13 +589,13 @@ struct yy_trans_info
 	flex_int32_t yy_verify;
 	flex_int32_t yy_nxt;
 	};
-static const flex_int16_t yy_accept[45] =
+static const flex_int16_t yy_accept[47] =
     {   0,
         0,    0,    0,    0,   30,    7,    7,   28,    6,   17,
         7,   27,   29,   26,   18,    5,    3,   16,   15,   13,
        11,    9,   14,   12,   10,    8,    0,    0,    0,    0,
-       25,   23,   21,   24,   22,   20,    0,    4,    0,    1,
-        2,   19,    0,    0
+        0,   25,   23,   21,   24,   22,   20,    0,    4,    0,
+        0,    1,    2,   19,    0,    0
     } ;
 
 static const YY_CHAR yy_ec[256] =
@@ -603,17 +603,17 @@ static const YY_CHAR yy_ec[256] =
         1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,    1,    3,    1,    1,    1,    3,
-        3,    3,    3,    4,    5,    3,    1,    6,    6,    6,
-        6,    6,    6,    6,    6,    6,    6,    1,    1,    1,
-        1,    1,    3,    1,    7,    8,    7,    9,    7,    7,
+        1,    3,    1,    1,    1,    4,    1,    1,    1,    4,
+        4,    4,    4,    5,    6,    4,    1,    7,    7,    7,
+        7,    7,    7,    7,    7,    7,    7,    1,    1,    1,
+        1,    1,    4,    1,    8,    9,    8,   10,    8,    8,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,   10,    1,    1,    1,   11,    1,    1,    1,
-       12,   13,   14,   15,    1,    1,    7,   16,    7,   17,
+        1,    1,   11,    1,    1,    1,   12,    1,    1,    1,
+       13,   14,   15,   16,    1,    1,    8,   17,    8,   18,
 
-        7,    7,    1,    1,    1,    1,    1,    1,    1,    1,
-        1,    1,    1,    1,   18,    1,    1,    1,   19,   20,
-        1,    1,   21,    3,   22,    1,    1,    1,    1,    1,
+        8,    8,    1,    1,    1,    1,    1,    1,    1,    1,
+        1,    1,    1,    1,   19,    1,    1,    1,   20,   21,
+        1,    1,   22,    4,   23,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
         1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
@@ -630,63 +630,69 @@ static const YY_CHAR yy_ec[256] =
         1,    1,    1,    1,    1
     } ;
 
-static const YY_CHAR yy_meta[23] =
+static const YY_CHAR yy_meta[24] =
     {   0,
-        1,    2,    1,    1,    3,    4,    4,    4,    4,    1,
-        1,    1,    1,    5,    1,    4,    4,    1,    1,    1,
-        1,    1
+        1,    2,    1,    1,    1,    3,    4,    4,    4,    4,
+        1,    1,    1,    1,    5,    1,    4,    4,    1,    1,
+        1,    1,    1
     } ;
 
-static const flex_int16_t yy_base[51] =
+static const flex_int16_t yy_base[53] =
     {   0,
-        0,   20,    3,    5,   49,   89,   89,   89,   10,   36,
-        0,   43,   38,   47,   89,   89,   26,   33,   89,   89,
-       89,   89,   89,   89,   89,   89,    4,    5,    0,   33,
-       32,   31,   29,   26,   24,   23,   15,   89,    8,   89,
-       89,   89,    0,   89,   67,   72,   77,   82,   84,    4
+        0,   21,    3,    5,   53,  112,  112,  112,   11,   37,
+        3,   45,   44,   48,  112,  112,   27,   33,  112,  112,
+      112,  112,  112,  112,  112,  112,    6,   29,   67,    0,
+       33,   32,   27,   25,   24,   23,   18,   15,  112,   38,
+        5,  112,  112,  112,    0,  112,   90,   95,  100,  105,
+      107,   11
     } ;
 
-static const flex_int16_t yy_def[51] =
+static const flex_int16_t yy_def[53] =
     {   0,
-       45,   45,   46,   46,   44,   44,   44,   44,   44,   44,
-       44,   44,   44,   47,   44,   44,   44,   44,   44,   44,
-       44,   44,   44,   44,   44,   44,   44,   44,   48,   44,
-       44,   44,   44,   44,   44,   44,   49,   44,   44,   44,
-       44,   44,   50,    0,   44,   44,   44,   44,   44,   44
+       47,   47,   48,   48,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   49,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46,   46,   46,   46,   46,   50,
+       46,   46,   46,   46,   46,   46,   46,   51,   46,   46,
+       46,   46,   46,   46,   52,    0,   46,   46,   46,   46,
+       46,   46
     } ;
 
-static const flex_int16_t yy_nxt[112] =
+static const flex_int16_t yy_nxt[136] =
     {   0,
-       44,    7,    8,   27,   13,   28,   13,   30,   27,   39,
-       28,    9,   10,   39,    8,   14,   15,   14,   15,   29,
-       11,    7,    8,   16,   17,   40,   41,   29,   29,   40,
-       29,    9,   10,   29,    8,   29,   29,   29,   18,   38,
-       11,   18,   29,   19,   20,   21,   22,   29,   44,   44,
-       44,   23,   24,   25,   26,   31,   32,   33,   44,   44,
-       44,   44,   44,   34,   35,   36,   37,    6,    6,    6,
-        6,    6,   12,   12,   12,   12,   12,   30,   44,   30,
-       30,   30,   42,   42,   42,   42,   43,   43,    5,   44,
-       44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
-
-       44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
-       44
+       46,    7,   46,    8,   13,   27,   13,   28,   27,   29,
+       28,   41,    9,   10,   31,    8,   14,   15,   14,   15,
+       30,   11,    7,   30,    8,   16,   17,   42,   30,   30,
+       30,   40,   30,    9,   10,   41,    8,   30,   30,   18,
+       40,   39,   11,   18,   41,   19,   20,   21,   22,   30,
+       30,   42,   46,   23,   24,   25,   26,   32,   33,   34,
+       42,   46,   46,   46,   46,   35,   36,   37,   38,   27,
+       46,   28,   46,   29,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46,   46,   46,   46,   46,   43,
+        6,    6,    6,    6,    6,   12,   12,   12,   12,   12,
+
+       31,   46,   31,   31,   31,   44,   44,   44,   44,   45,
+       45,    5,   46,   46,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46
     } ;
 
-static const flex_int16_t yy_chk[112] =
+static const flex_int16_t yy_chk[136] =
     {   0,
-        0,    1,    1,   11,    3,   11,    4,   50,   28,   27,
-       28,    1,    1,   39,    1,    3,    3,    4,    4,   37,
-        1,    2,    2,    9,    9,   27,   28,   36,   35,   39,
-       34,    2,    2,   33,    2,   32,   31,   30,   18,   17,
-        2,   10,   13,   10,   10,   10,   10,   12,    5,    0,
-        0,   10,   10,   10,   10,   14,   14,   14,    0,    0,
-        0,    0,    0,   14,   14,   14,   14,   45,   45,   45,
-       45,   45,   46,   46,   46,   46,   46,   47,    0,   47,
-       47,   47,   48,   48,   48,   48,   49,   49,   44,   44,
-       44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
-
-       44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
-       44
+        0,    1,    0,    1,    3,   11,    4,   11,   27,   11,
+       27,   41,    1,    1,   52,    1,    3,    3,    4,    4,
+       38,    1,    2,   37,    2,    9,    9,   41,   36,   35,
+       34,   28,   33,    2,    2,   28,    2,   32,   31,   18,
+       40,   17,    2,   10,   40,   10,   10,   10,   10,   13,
+       12,   28,    5,   10,   10,   10,   10,   14,   14,   14,
+       40,    0,    0,    0,    0,   14,   14,   14,   14,   29,
+        0,   29,    0,   29,    0,    0,    0,    0,    0,    0,
+        0,    0,    0,    0,    0,    0,    0,    0,    0,   29,
+       47,   47,   47,   47,   47,   48,   48,   48,   48,   48,
+
+       49,    0,   49,   49,   49,   50,   50,   50,   50,   51,
+       51,   46,   46,   46,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
+       46,   46,   46,   46,   46
     } ;
 
 /* Table of booleans, true if rule could match eol. */
@@ -794,10 +800,10 @@ int read_escaped_char(
     uint8_t* escaped_char,
     bool strict_escape);
 
-#line 797 "libyara/re_lexer.c"
+#line 803 "libyara/re_lexer.c"
 #define YY_NO_UNISTD_H 1
 
-#line 800 "libyara/re_lexer.c"
+#line 806 "libyara/re_lexer.c"
 
 #define INITIAL 0
 #define char_class 1
@@ -1073,7 +1079,7 @@ YY_DECL
 #line 114 "libyara/re_lexer.l"
 
 
-#line 1076 "libyara/re_lexer.c"
+#line 1082 "libyara/re_lexer.c"
 
 	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
 		{
@@ -1100,13 +1106,13 @@ yy_match:
 			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 				{
 				yy_current_state = (int) yy_def[yy_current_state];
-				if ( yy_current_state >= 45 )
+				if ( yy_current_state >= 47 )
 					yy_c = yy_meta[yy_c];
 				}
 			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
 			++yy_cp;
 			}
-		while ( yy_current_state != 44 );
+		while ( yy_current_state != 46 );
 		yy_cp = yyg->yy_last_accepting_cpos;
 		yy_current_state = yyg->yy_last_accepting_state;
 
@@ -1143,19 +1149,21 @@ YY_RULE_SETUP
 #line 116 "libyara/re_lexer.l"
 {
 
-  // Examples: {3,8} {0,5} {,5} {7,}
+  // Examples: {3,8} {3, 8}, {3 ,8} {3 , 8} {0,5} {,5} {7,}
 
   int hi_bound;
   int lo_bound = atoi(yytext + 1);
 
   char* comma = strchr(yytext, ',');
+  char* hi_bound_ptr = comma + 1;
 
-  if (comma - yytext == strlen(yytext) - 2)
-    // if comma is followed by the closing curly bracket
-    // (example: {2,}) set high bound value to maximum.
+  // Skip spaces after the comma, if any.
+  while (*hi_bound_ptr == ' ') hi_bound_ptr++;
+
+  if (*hi_bound_ptr == '}')
     hi_bound = RE_MAX_RANGE;
   else
-    hi_bound = atoi(comma + 1);
+    hi_bound = atoi(hi_bound_ptr);
 
   if (hi_bound > RE_MAX_RANGE)
   {
@@ -1176,7 +1184,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 2:
 YY_RULE_SETUP
-#line 150 "libyara/re_lexer.l"
+#line 152 "libyara/re_lexer.l"
 {
 
   // Example: {10}
@@ -1199,7 +1207,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 3:
 YY_RULE_SETUP
-#line 171 "libyara/re_lexer.l"
+#line 173 "libyara/re_lexer.l"
 {
 
   // Start of a negated character class. Example: [^abcd]
@@ -1211,7 +1219,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 4:
 YY_RULE_SETUP
-#line 180 "libyara/re_lexer.l"
+#line 182 "libyara/re_lexer.l"
 {
 
   // Start of character negated class containing a ].
@@ -1226,7 +1234,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 5:
 YY_RULE_SETUP
-#line 193 "libyara/re_lexer.l"
+#line 195 "libyara/re_lexer.l"
 {
 
   // Start of character class containing a ].
@@ -1241,7 +1249,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 6:
 YY_RULE_SETUP
-#line 206 "libyara/re_lexer.l"
+#line 208 "libyara/re_lexer.l"
 {
 
   // Start of character class. Example: [abcd]
@@ -1254,7 +1262,7 @@ YY_RULE_SETUP
 case 7:
 /* rule 7 can match eol */
 YY_RULE_SETUP
-#line 216 "libyara/re_lexer.l"
+#line 218 "libyara/re_lexer.l"
 {
 
   // Any non-special character is passed as a CHAR token to the scanner.
@@ -1265,63 +1273,63 @@ YY_RULE_SETUP
 	YY_BREAK
 case 8:
 YY_RULE_SETUP
-#line 225 "libyara/re_lexer.l"
+#line 227 "libyara/re_lexer.l"
 {
   return _WORD_CHAR_;
 }
 	YY_BREAK
 case 9:
 YY_RULE_SETUP
-#line 230 "libyara/re_lexer.l"
+#line 232 "libyara/re_lexer.l"
 {
   return _NON_WORD_CHAR_;
 }
 	YY_BREAK
 case 10:
 YY_RULE_SETUP
-#line 235 "libyara/re_lexer.l"
+#line 237 "libyara/re_lexer.l"
 {
   return _SPACE_;
 }
 	YY_BREAK
 case 11:
 YY_RULE_SETUP
-#line 240 "libyara/re_lexer.l"
+#line 242 "libyara/re_lexer.l"
 {
   return _NON_SPACE_;
 }
 	YY_BREAK
 case 12:
 YY_RULE_SETUP
-#line 245 "libyara/re_lexer.l"
+#line 247 "libyara/re_lexer.l"
 {
   return _DIGIT_;
 }
 	YY_BREAK
 case 13:
 YY_RULE_SETUP
-#line 250 "libyara/re_lexer.l"
+#line 252 "libyara/re_lexer.l"
 {
   return _NON_DIGIT_;
 }
 	YY_BREAK
 case 14:
 YY_RULE_SETUP
-#line 255 "libyara/re_lexer.l"
+#line 257 "libyara/re_lexer.l"
 {
   return _WORD_BOUNDARY_;
 }
 	YY_BREAK
 case 15:
 YY_RULE_SETUP
-#line 259 "libyara/re_lexer.l"
+#line 261 "libyara/re_lexer.l"
 {
   return _NON_WORD_BOUNDARY_;
 }
 	YY_BREAK
 case 16:
 YY_RULE_SETUP
-#line 264 "libyara/re_lexer.l"
+#line 266 "libyara/re_lexer.l"
 {
 
   yyerror(yyscanner, lex_env, "backreferences are not allowed");
@@ -1330,7 +1338,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 17:
 YY_RULE_SETUP
-#line 271 "libyara/re_lexer.l"
+#line 273 "libyara/re_lexer.l"
 {
 
   uint8_t c;
@@ -1357,7 +1365,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 18:
 YY_RULE_SETUP
-#line 296 "libyara/re_lexer.l"
+#line 298 "libyara/re_lexer.l"
 {
 
   // End of character class.
@@ -1373,7 +1381,7 @@ YY_RULE_SETUP
 case 19:
 /* rule 19 can match eol */
 YY_RULE_SETUP
-#line 310 "libyara/re_lexer.l"
+#line 312 "libyara/re_lexer.l"
 {
 
   // A range inside a character class. The regexp is...
@@ -1438,7 +1446,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 20:
 YY_RULE_SETUP
-#line 373 "libyara/re_lexer.l"
+#line 375 "libyara/re_lexer.l"
 {
 
   for (int i = 0; i < 32; i++)
@@ -1447,7 +1455,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 21:
 YY_RULE_SETUP
-#line 380 "libyara/re_lexer.l"
+#line 382 "libyara/re_lexer.l"
 {
 
   for (int i = 0; i < 32; i++)
@@ -1456,7 +1464,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 22:
 YY_RULE_SETUP
-#line 387 "libyara/re_lexer.l"
+#line 389 "libyara/re_lexer.l"
 {
 
   for (int i = 0; i < 32; i++)
@@ -1465,7 +1473,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 23:
 YY_RULE_SETUP
-#line 394 "libyara/re_lexer.l"
+#line 396 "libyara/re_lexer.l"
 {
 
   for (int i = 0; i < 32; i++)
@@ -1474,7 +1482,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 24:
 YY_RULE_SETUP
-#line 401 "libyara/re_lexer.l"
+#line 403 "libyara/re_lexer.l"
 {
 
   for (char c = '0'; c <= '9'; c++)
@@ -1483,7 +1491,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 25:
 YY_RULE_SETUP
-#line 408 "libyara/re_lexer.l"
+#line 410 "libyara/re_lexer.l"
 {
 
   for (int i = 0; i < 32; i++)
@@ -1503,7 +1511,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 26:
 YY_RULE_SETUP
-#line 426 "libyara/re_lexer.l"
+#line 428 "libyara/re_lexer.l"
 {
 
   uint8_t c;
@@ -1528,7 +1536,7 @@ YY_RULE_SETUP
 	YY_BREAK
 case 27:
 YY_RULE_SETUP
-#line 449 "libyara/re_lexer.l"
+#line 451 "libyara/re_lexer.l"
 {
 
   if (yytext[0] >= 32 && yytext[0] < 127)
@@ -1546,7 +1554,7 @@ YY_RULE_SETUP
 }
 	YY_BREAK
 case YY_STATE_EOF(char_class):
-#line 466 "libyara/re_lexer.l"
+#line 468 "libyara/re_lexer.l"
 {
 
   // End of regexp reached while scanning a character class.
@@ -1557,7 +1565,7 @@ case YY_STATE_EOF(char_class):
 	YY_BREAK
 case 28:
 YY_RULE_SETUP
-#line 475 "libyara/re_lexer.l"
+#line 477 "libyara/re_lexer.l"
 {
 
   if (yytext[0] >= 32 && yytext[0] < 127)
@@ -1572,7 +1580,7 @@ YY_RULE_SETUP
 }
 	YY_BREAK
 case YY_STATE_EOF(INITIAL):
-#line 489 "libyara/re_lexer.l"
+#line 491 "libyara/re_lexer.l"
 {
 
   yyterminate();
@@ -1580,10 +1588,10 @@ case YY_STATE_EOF(INITIAL):
 	YY_BREAK
 case 29:
 YY_RULE_SETUP
-#line 494 "libyara/re_lexer.l"
+#line 496 "libyara/re_lexer.l"
 ECHO;
 	YY_BREAK
-#line 1586 "libyara/re_lexer.c"
+#line 1594 "libyara/re_lexer.c"
 
 	case YY_END_OF_BUFFER:
 		{
@@ -1881,7 +1889,7 @@ static int yy_get_next_buffer (yyscan_t
 		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 			{
 			yy_current_state = (int) yy_def[yy_current_state];
-			if ( yy_current_state >= 45 )
+			if ( yy_current_state >= 47 )
 				yy_c = yy_meta[yy_c];
 			}
 		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
@@ -1910,11 +1918,11 @@ static int yy_get_next_buffer (yyscan_t
 	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
 		{
 		yy_current_state = (int) yy_def[yy_current_state];
-		if ( yy_current_state >= 45 )
+		if ( yy_current_state >= 47 )
 			yy_c = yy_meta[yy_c];
 		}
 	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
-	yy_is_jam = (yy_current_state == 44);
+	yy_is_jam = (yy_current_state == 46);
 
 	(void)yyg;
 	return yy_is_jam ? 0 : yy_current_state;
@@ -2732,7 +2740,7 @@ void yyfree (void * ptr , yyscan_t yysca
 
 #define YYTABLES_NAME "yytables"
 
-#line 494 "libyara/re_lexer.l"
+#line 496 "libyara/re_lexer.l"
 
 
 int escaped_char_value(
@@ -2954,6 +2962,7 @@ int yr_parse_re_string(
 
   yyset_extra(*re_ast, yyscanner);
   yy_scan_string(re_string, yyscanner);
+
   yyparse(yyscanner, &lex_env);
   yylex_destroy(yyscanner);
 
diff -pruN 4.5.0-1/libyara/re_lexer.l 4.5.1-1/libyara/re_lexer.l
--- 4.5.0-1/libyara/re_lexer.l	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/libyara/re_lexer.l	2024-05-25 10:23:51.000000000 +0000
@@ -113,21 +113,23 @@ hex_digit     [0-9a-fA-F]
 
 %%
 
-\{{digit}*,{digit}*\} {
+\{{digit}*[ ]*,[ ]*{digit}*\} {
 
-  // Examples: {3,8} {0,5} {,5} {7,}
+  // Examples: {3,8} {3, 8}, {3 ,8} {3 , 8} {0,5} {,5} {7,}
 
   int hi_bound;
   int lo_bound = atoi(yytext + 1);
 
   char* comma = strchr(yytext, ',');
+  char* hi_bound_ptr = comma + 1;
 
-  if (comma - yytext == strlen(yytext) - 2)
-    // if comma is followed by the closing curly bracket
-    // (example: {2,}) set high bound value to maximum.
+  // Skip spaces after the comma, if any.
+  while (*hi_bound_ptr == ' ') hi_bound_ptr++;
+
+  if (*hi_bound_ptr == '}')
     hi_bound = RE_MAX_RANGE;
   else
-    hi_bound = atoi(comma + 1);
+    hi_bound = atoi(hi_bound_ptr);
 
   if (hi_bound > RE_MAX_RANGE)
   {
@@ -712,6 +714,7 @@ int yr_parse_re_string(
 
   yyset_extra(*re_ast, yyscanner);
   yy_scan_string(re_string, yyscanner);
+
   yyparse(yyscanner, &lex_env);
   yylex_destroy(yyscanner);
 
diff -pruN 4.5.0-1/tests/test-alignment.c 4.5.1-1/tests/test-alignment.c
--- 4.5.0-1/tests/test-alignment.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/tests/test-alignment.c	2024-05-25 10:23:51.000000000 +0000
@@ -36,8 +36,6 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBI
 
 #include "util.h"
 
-int err = 0;
-
 #define CHECK_SIZE(expr, size)                           \
   do                                                     \
   {                                                      \
@@ -49,7 +47,7 @@ int err = 0;
     else                                                 \
     {                                                    \
       printf("expected %d\n", size);                     \
-      err = 1;                                           \
+      return 1;                                          \
     }                                                    \
   } while (0);
 
@@ -66,16 +64,13 @@ int err = 0;
     else                                               \
     {                                                  \
       printf("expected %d\n", offset);                 \
-      err = 1;                                         \
+      return 1;                                        \
     }                                                  \
   } while (0)
 
 int main(int argc, char **argv)
 {
-  int result = err;
-
   YR_DEBUG_INITIALIZE();
-  YR_DEBUG_FPRINTF(1, stderr, "+ %s() { // in %s\n", __FUNCTION__, argv[0]);
 
   CHECK_SIZE(YR_SUMMARY, 12);
   CHECK_OFFSET(YR_SUMMARY, 0, num_rules);
@@ -114,12 +109,15 @@ int main(int argc, char **argv)
   CHECK_OFFSET(YR_STRING, 44, chain_gap_max);
   CHECK_OFFSET(YR_STRING, 48, identifier);
 
-  CHECK_SIZE(YR_RULE, 48);
-  CHECK_OFFSET(YR_RULE, 8, identifier);
-  CHECK_OFFSET(YR_RULE, 16, tags);
-  CHECK_OFFSET(YR_RULE, 24, metas);
-  CHECK_OFFSET(YR_RULE, 32, strings);
-  CHECK_OFFSET(YR_RULE, 40, ns);
+  CHECK_SIZE(YR_RULE, 56);
+  CHECK_OFFSET(YR_RULE, 0, flags);
+  CHECK_OFFSET(YR_RULE, 4, num_atoms);
+  CHECK_OFFSET(YR_RULE, 8, required_strings);
+  CHECK_OFFSET(YR_RULE, 16, identifier);
+  CHECK_OFFSET(YR_RULE, 24, tags);
+  CHECK_OFFSET(YR_RULE, 32, metas);
+  CHECK_OFFSET(YR_RULE, 40, strings);
+  CHECK_OFFSET(YR_RULE, 48, ns);
 
   CHECK_SIZE(YR_EXTERNAL_VARIABLE, 24);
   CHECK_OFFSET(YR_EXTERNAL_VARIABLE, 8, value.i);
@@ -134,8 +132,5 @@ int main(int argc, char **argv)
   CHECK_OFFSET(YR_AC_MATCH, 24, next);
   CHECK_OFFSET(YR_AC_MATCH, 32, backtrack);
 
-  YR_DEBUG_FPRINTF(
-      1, stderr, "} = %d // %s() in %s\n", result, __FUNCTION__, argv[0]);
-
-  return result;
+  return 0;
 }
diff -pruN 4.5.0-1/tests/test-math.c 4.5.1-1/tests/test-math.c
--- 4.5.0-1/tests/test-math.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/tests/test-math.c	2024-05-25 10:23:51.000000000 +0000
@@ -195,6 +195,14 @@ int main(int argc, char** argv)
       "import \"math\" \
       rule test { \
         condition: \
+          math.entropy(\"\") == 0.0 \
+      }",
+      NULL);
+
+  assert_true_rule(
+      "import \"math\" \
+      rule test { \
+        condition: \
           math.entropy(\"AABB\") == 1.0 \
       }",
       NULL);
diff -pruN 4.5.0-1/tests/test-rules.c 4.5.1-1/tests/test-rules.c
--- 4.5.0-1/tests/test-rules.c	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/tests/test-rules.c	2024-05-25 10:23:51.000000000 +0000
@@ -1629,6 +1629,19 @@ static void test_hex_strings()
         condition: $a }",
       "1234567890");
 
+  // Test case for https://github.com/VirusTotal/yara/issues/2065
+  uint8_t ISSUE_2065[] = {0x81, 0xEC, 0x38, 0x01, 0x00, 0x00, 0x00, 0x00,
+                          0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+                          0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+                          0x00, 0x00, 0x00, 0x00, 0x00, 0xB8, 0x00, 0x00,
+                          0x00, 0x00, 0x44, 0x55, 0x66, 0x77};
+
+  assert_true_rule_blob(
+      "rule test { \
+        strings: $a = { 81 EC 38 01 [4-25] B8 ?? ?? ?? ?? [20-21] 44 55 66 77  } \
+        condition: $a }",
+      ISSUE_2065);
+
   assert_error(
       "rule test { \
         strings: $a = { 01 [0] 02 } \
@@ -2497,6 +2510,9 @@ void test_re()
   assert_true_regexp("a.b{2,3}cccc", "aabbbcccc", "aabbbcccc");
   assert_true_regexp("ab{2,3}c", "abbbc", "abbbc");
   assert_true_regexp("ab{2,3}?c", "abbbc", "abbbc");
+  assert_true_regexp("ab{2, 3}c", "abbbc", "abbbc");
+  assert_true_regexp("ab{2 ,3}c", "abbbc", "abbbc");
+  assert_true_regexp("ab{2  ,  3}c", "abbbc", "abbbc");
   assert_true_regexp("ab{0,1}?c", "abc", "abc");
   assert_true_regexp("a{0,1}?bc", "abc", "abc");
   assert_true_regexp("a{0,1}bc", "bbc", "bc");
@@ -2574,6 +2590,8 @@ void test_re()
   assert_true_regexp("a[b-]", "a-", "a-");
   assert_true_regexp("a[b-]", "ab", "ab");
   assert_true_regexp("[a-c-e]", "b", "b");
+  assert_true_regexp("[a-c-e]+", "abc", "abc");
+  assert_true_regexp("[*-_]+", "ABC", "ABC");
   assert_true_regexp("[a-c-e]", "-", "-");
   assert_false_regexp("[a-c-e]", "d");
   assert_regexp_syntax_error("[b-a]");
@@ -2792,6 +2810,13 @@ void test_re()
       "rule test { strings: $a = /abc[^F]/ condition: $a }",
       TEXT_1024_BYTES "abcd");
 
+  assert_true_rule(
+      "rule test { strings: $a = /[*-_]+/ nocase condition: !a == 3 }", "abc");
+
+  assert_true_rule(
+      "rule test { strings: $a = /([$&#*-_!().])+/ nocase condition: !a == 6 }",
+      "ABCabc");
+
   // Test case for issue #1006
   assert_false_rule_blob(
       "rule test { strings: $a = \" cmd.exe \" nocase wide condition: $a }",
@@ -2953,6 +2978,12 @@ static void test_matches_operator()
   assert_false_rule(
       "rule test { condition: \"foo\\nbar\" matches /foo.*bar/ }", NULL);
 
+  assert_true_rule("rule test { condition: \"\" matches /foo|/ }", NULL);
+
+  assert_true_rule("rule test { condition: \"\" matches /a||b/ }", NULL);
+
+  assert_false_rule("rule test { condition: \"\" matches /foobar/ }", NULL);
+
   YR_DEBUG_FPRINTF(1, stderr, "} // %s()\n", __FUNCTION__);
 }
 
diff -pruN 4.5.0-1/yara.man 4.5.1-1/yara.man
--- 4.5.0-1/yara.man	2024-02-13 11:33:22.000000000 +0000
+++ 4.5.1-1/yara.man	2024-05-25 10:23:51.000000000 +0000
@@ -103,6 +103,9 @@ in bytes when scanning a directory.
 Set maximum stack size to the specified number of
 .I slots.
 .TP
+.BI "    --strict-escape"
+Print warnings if rules contain ambiguous escape statements.
+.TP
 .BI \-t " tag" " --tag=" tag
 Print rules tagged as
 .I tag
